import { jsx as _jsx } from "react/jsx-runtime";
import styled from 'styled-components';
import { motion } from 'framer-motion';
import theme from '../../../../theme';
export default function Divider(props) {
    return _jsx(DividerStyled, Object.assign({}, props));
}
Divider.defaultProps = {
    thickness: 1,
    color: theme.colors.black,
    direction: 'horizontal',
    length: 500,
    isFullWidth: false,
};
const DividerStyled = styled(motion.div) `
  width: ${({ direction, thickness, length, isFullWidth }) => (isFullWidth ? '100%' : direction === 'vertical' ? thickness : length)}px;
  height: ${({ direction, thickness, length }) => (direction === 'vertical' ? length : thickness)}px;
  background: ${({ color }) => color};
  margin: ${props => props.margin};
`;
