var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import styled from 'styled-components';
import { startCase, camelCase } from 'lodash-es';
import * as FeatherIcons from 'react-icons/fi';
import { featherIconNames } from './featherIcon';
import theme from '../../../../theme';
export const iconNames = [...featherIconNames];
export default function Icon(props) {
    const { size, color, name, backgroundColor } = props, remain = __rest(props, ["size", "color", "name", "backgroundColor"]);
    const iconNameByPascalCase = startCase(camelCase(name)).replace(/ /g, '');
    const FeatherIcon = FeatherIcons[`Fi${iconNameByPascalCase}`];
    if (!FeatherIcon)
        return null;
    return (_jsx(Box, Object.assign({ size: size, backgroundColor: backgroundColor }, { children: _jsx(FeatherIcon, { size: size, color: color }) })));
}
Icon.defaultProps = {
    name: null,
    size: 24,
    color: theme.colors.black,
    backgroundColor: 'transparent',
};
const Box = styled.div `
  display: block;
  width: ${props => props.size}px;
  height: ${props => props.size}px;
  min-width: ${props => props.size}px;
  min-height: ${props => props.size}px;
  max-width: ${props => props.size}px;
  max-height: ${props => props.size}px;
  line-height: 0;
  vertical-align: bottom;
  background: ${({ backgroundColor }) => backgroundColor};
`;
