var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import styled, { css } from 'styled-components';
import { isEmpty } from 'lodash-es';
import theme from '../../../../theme';
import { colorUtil } from '../../../../utils/ColorUtil';
import { textUtil } from '../../../../utils/TextUtil';
function Paragraph(props) {
    const { size, content, isVisible, partialColors } = props, remain = __rest(props, ["size", "content", "isVisible", "partialColors"]);
    const texts = textUtil.processTextWithNewlines(content);
    if (!isVisible)
        return null;
    return (_jsx(ParagraphStyled, Object.assign({}, props, { children: texts === null || texts === void 0 ? void 0 : texts.map((text, i) => {
            const replacedText = colorUtil.applyColorsToText(text, partialColors);
            /** 텍스트가 가공된 경우 */
            if (!isEmpty(replacedText)) {
                const innerHtml = { __html: replacedText };
                return (_jsxs(_Fragment, { children: [_jsx("span", { dangerouslySetInnerHTML: innerHtml }, i), _jsx("br", {})] }));
            }
            /** 텍스트가 가공되지 않은 경우 */
            return (_jsxs(_Fragment, { children: [_jsx("span", { children: text }, i), _jsx("br", {})] }));
        }) })));
}
Paragraph.defaultProps = {
    content: 'Paragraph Paragraph Paragraph\nParagraph Paragraph Paragraph',
    size: 'md',
    color: theme.colors.black,
    partialColors: [theme.colors.black],
    fontWeight: 'normal',
    isMobile: false,
    isVisible: true,
    isFullWidth: false,
    textAlign: 'left',
};
export default Paragraph;
const ParagraphCommonStyles = css `
  font-family: ${props => (props.fontWeight === 'bold' ? `${theme.fontFamily.bold}` : `${theme.fontFamily.normal}`)};
  font-weight: normal;
  color: ${props => props.color};
  line-height: 1.5em;
  margin: 0;
  text-align: ${props => props.textAlign};
  white-space: ${props => props.whiteSpace};
`;
export const smallFontStyles = css `
  font-size: ${props => (!props.isMobile ? '16px' : '12px')};
  letter-spacing: ${props => (!props.isMobile ? '-0.3px' : '-0.2px')};
  line-height: 1.25;
`;
export const mediumFontStyles = css `
  font-size: ${props => (!props.isMobile ? '18px' : '14px')};
  letter-spacing: ${props => (!props.isMobile ? '-0.3px' : '-0.2px')};
`;
export const largeFontStyles = css `
  font-size: ${props => (!props.isMobile ? '21px' : '14px')};
  letter-spacing: ${props => (!props.isMobile ? '-0.4px' : '-0.2px')};
`;
export const ParagraphStyled = styled.p `
  ${ParagraphCommonStyles};
  ${props => props.size === 'sm' && smallFontStyles};
  ${props => props.size === 'md' && mediumFontStyles};
  ${props => props.size === 'lg' && largeFontStyles};
  margin: ${props => props.margin};
  padding: ${props => props.padding};
  width: ${props => (props.isFullWidth ? '100%' : 'auto')};
`;
