import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import styled from 'styled-components';
import { motion } from 'framer-motion';
import theme from '../../../../theme';
import { Stack } from '../../../layout';
const CheckIcon = (props) => {
    return (_jsx("svg", Object.assign({ xmlns: "http://www.w3.org/2000/svg", width: "14", height: "11" }, props, { children: _jsx("path", { d: "M 12.333 1.692 L 5 9.308 L 1.667 5.846", fill: "transparent", strokeWidth: "2", stroke: "hsl(0, 0%, 100%)", strokeLinecap: "round", strokeLinejoin: "round" }) })));
};
export default function CheckBoxInput(props) {
    const { isActive, label, defaultColor, activeColor } = props;
    return (_jsxs(Box, { children: [_jsxs(Stack, Object.assign({ gap: 8 }, { children: [_jsx(CheckBoxIcon, Object.assign({ isActive: isActive, defaultColor: defaultColor, activeColor: activeColor }, { children: isActive && _jsx(CheckIconStyled, { color: theme.colors.white }) })), label.text && (_jsx(LabelStyled, Object.assign({ isActive: isActive, defaultColor: defaultColor, activeColor: activeColor }, { children: label.text })))] })), _jsx(VisuallyHiddenRadio, { type: "checkbox", checked: isActive })] }));
}
CheckBoxInput.defaultProps = {
    isActive: true,
    defaultColor: theme.colors.gray300,
    activeColor: theme.colors.black,
    label: {
        text: 'Check',
    },
};
const Box = styled(motion.div) `
  display: flex;
  position: relative;
  font-family: ${theme.fontFamily.normal};
`;
const CheckIconStyled = styled(CheckIcon) `
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
`;
const CheckBoxIcon = styled(motion.div) `
  width: 24px;
  height: 24px;
  position: relative;
  border: 2px solid ${({ isActive, activeColor, defaultColor }) => (isActive ? 'none' : defaultColor)};
  background: ${({ isActive, activeColor, defaultColor }) => (isActive ? activeColor : 'none')};
  border-radius: 6px;
`;
const LabelStyled = styled(motion.label) `
  font-size: 16px;
  line-height: 1.5;
  letter-spacing: -0.3px;
  color: ${({ isActive, activeColor, defaultColor }) => (isActive ? activeColor : defaultColor)};
  font-family: ${({ isActive }) => (isActive ? theme.fontFamily.bold : theme.fontFamily.normal)};
`;
const VisuallyHiddenRadio = styled.input `
  position: absolute;
  width: 1px;
  height: 1px;
  padding: 0;
  margin: -1px;
  overflow: hidden;
  clip: rect(0, 0, 0, 0);
  white-space: nowrap;
  border: 0;
`;
