var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { useState } from 'react';
import styled from 'styled-components';
import { motion } from 'framer-motion';
import Title from '../../atoms/Title/Title';
import Button from '../Button/Button';
export default function Drawer(props) {
    const { title, onClose, openButton, children } = props, remain = __rest(props, ["title", "onClose", "openButton", "children"]);
    const [isOpen, setIsOpen] = useState(false);
    const [isAnimating, setIsAnimating] = useState(false);
    const toggleDrawer = () => setIsOpen(state => !state);
    const handleAnimationComplete = () => {
        setIsAnimating(false);
    };
    const handleClose = () => {
        if (isOpen && !isAnimating) {
            setIsAnimating(true);
            onClose();
        }
    };
    const variants = {
        open: { x: 0 },
        closed: { x: '100%' },
    };
    return (_jsxs(_Fragment, { children: [_jsx(OpenButtonArea, Object.assign({ onClick: toggleDrawer }, { children: openButton })), isOpen && (_jsxs(DrawerBox, Object.assign({ initial: "closed", animate: "open", exit: "closed", variants: variants, onAnimationComplete: handleAnimationComplete, onClick: handleClose }, { children: [_jsxs(DrawerContent, { children: [_jsxs(DrawerHeaderArea, { children: [_jsx(Title, { content: title }), _jsx(Button, { onClick: toggleDrawer, content: "", icon: "x", size: "sm", iconPosition: "right" })] }), _jsx(DrawerBodyArea, { children: children })] }), _jsx(DrawerOverlay, { onClick: () => setIsOpen(false), exit: { opacity: 0 }, transition: { duration: 1 } })] })))] }));
}
Drawer.defaultProps = {
    openButton: _jsx(Button, { buttonType: "ghost" }),
    title: 'Drawer 제목입니다 Drawer 제목입니다 Drawer 제목입니다 Drawer 제목입니다 Drawer 제목입니다',
    children: 'Drawer 내부 컴포넌트를 설정해주세요',
};
const OpenButtonArea = styled(motion.div) ``;
const DrawerBox = styled(motion.div) `
  position: fixed;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  z-index: 999;
  background-color: #fff;
  overflow-x: hidden;
  overflow-y: auto;
`;
const DrawerContent = styled(motion.div) `
  display: flex;
  flex-direction: column;
  position: relative;
  padding: 16px;
  background-color: #fff;
  z-index: 999;
  width: 100%;
  height: 100%;
`;
const DrawerHeaderArea = styled(motion.div) `
  display: flex;
  width: 100%;
  justify-content: space-between;
`;
const DrawerBodyArea = styled(motion.div) `
  display: flex;
  width: 100%;
  flex: 1;
  margin-top: 24px;
`;
const DrawerOverlay = styled(motion.div) `
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background-color: rgba(0, 0, 0, 0.1);
`;
