var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useCallback, useState } from 'react';
import styled from 'styled-components';
import { motion } from 'framer-motion';
import theme from '../../../../theme';
import IconButton from '../IconButton/IconButton';
export default function TextInput(props) {
    const { children, onClearButtonClicked, placeholder, isActiveDeleteIcon, isFullWidth } = props, inputProps = __rest(props, ["children", "onClearButtonClicked", "placeholder", "isActiveDeleteIcon", "isFullWidth"]);
    const [value, setValue] = useState('');
    const handleChange = useCallback(e => {
        const text = e.target.value;
        setValue(text);
    }, []);
    const handleClearButtonClicked = useCallback(() => {
        setValue('');
        onClearButtonClicked && onClearButtonClicked(value);
    }, [onClearButtonClicked]);
    return (_jsxs(Box, Object.assign({ isFullWidth: isFullWidth }, { children: [_jsx(Input, Object.assign({ value: value, onChange: handleChange, placeholder: placeholder.text, placeholderColor: placeholder.color, isActiveDeleteIcon: isActiveDeleteIcon, isFullWidth: isFullWidth }, inputProps)), isActiveDeleteIcon && (_jsx(IconButtonArea, Object.assign({ onClick: handleClearButtonClicked }, { children: _jsx(IconButton, { icon: "x-circle", color: theme.colors.gray300 }) })))] })));
}
TextInput.defaultProps = {
    placeholder: {
        color: theme.colors.gray300,
        text: 'Placeholder',
    },
    text: {
        color: theme.colors.black,
        size: 16,
    },
    border: {
        color: 'rgba(0,0,0,0.1)',
        hoverColor: 'rgba(0,0,0,0.3)',
    },
    disable: {
        isDisabled: false,
        fillColor: theme.colors.gray50,
    },
    isActiveDeleteIcon: true,
    isFullWidth: true,
    onClearButtonClicked: (text) => console.log(`X버튼 클릭됨: ${text}`),
};
const IconButtonArea = styled(motion.div) `
  display: none;
  position: absolute;
  top: 50%;
  right: 20px;
  transform: translateY(-50%);
  :active {
    display: block;
  }
`;
const Input = styled(motion.input) `
  padding: 12px 20px;
  border-radius: 12px;
  border: 1px solid ${({ border }) => border.color};
  cursor: pointer;
  background-color: ${({ disable }) => (disable.isDisabled ? disable.fillColor : theme.colors.white)};
  font-family: ${theme.fontFamily.normal};
  font-size: ${({ text }) => text.size}px;
  line-height: 1.5;
  letter-spacing: -0.3;
  color: ${({ text }) => text.color};
  width: ${props => (props.isFullWidth ? '100%' : 'auto')};

  ::placeholder {
    color: ${({ placeholderColor }) => placeholderColor};
    font-size: ${({ text }) => text.size}px;
    line-height: 1.5;
    letter-spacing: -0.3;
    font-family: ${theme.fontFamily.normal};
  }
  :active,
  :focus,
  :hover {
    outline: none;
    border: 1px solid ${({ border }) => border.hoverColor};
  }
  :active,
  :focus {
    & + ${IconButtonArea} {
      display: block;
    }
    ${props => props.isActiveDeleteIcon &&
    `padding: 12px 54px 12px 20px;
    `};
  }
`;
const Box = styled(motion.div) `
  display: flex;
  position: relative;
  width: ${props => (props.isFullWidth ? '100%' : 'auto')};
`;
