import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import styled from 'styled-components';
import { motion } from 'framer-motion';
import { produce } from 'immer';
import theme from '../../../../theme';
import Paragraph from '../../atoms/Paragraph/Paragraph';
import Button from '../../molecules/Button/Button';
import Title from '../../atoms/Title/Title';
export default function Card1(props) {
    const { backgroundColor, logoUrl, title, description, name, company, buttonProps, isMobile } = props;
    return (_jsxs(Box, Object.assign({ backgroundColor: backgroundColor, isMobile: isMobile }, { children: [_jsx(Logo, { isMobile: isMobile, src: logoUrl }), _jsx(Paragraph, Object.assign({ margin: isMobile ? '16px 0 0' : '32px 0 0' }, title, { isMobile: isMobile })), _jsx(Paragraph, Object.assign({ margin: "4px 0 0" }, description, { isMobile: isMobile })), _jsx(Paragraph, Object.assign({ margin: isMobile ? '35px 0 0' : '51px 0 0' }, name, { isMobile: isMobile })), _jsx(Paragraph, Object.assign({}, company, { isMobile: isMobile })), _jsx(Button, Object.assign({ size: isMobile ? 'sm' : 'md', margin: "16px 0 0" }, buttonProps))] })));
}
Card1.defaultProps = {
    logoUrl: 'https://codeindesign.s3.ap-northeast-2.amazonaws.com/CodeInDesign+Logo.png',
    title: produce(Title.defaultProps, draft => {
        draft.fontWeight = 'bold';
        draft.size = 'md';
        draft.color = theme.colors.gray500;
        draft.content = '이곳은 제목이 들어가는 영역입니다\n개행처리도 아주 잘 됩니다';
    }),
    description: produce(Title.defaultProps, draft => {
        draft.fontWeight = 'bold';
        draft.size = 'md';
        draft.color = theme.colors.gray500;
        draft.content = '비즈니스 PT 받은 느낌이에요!비즈니스 PT 받은 느낌이에요!';
    }),
    name: produce(Title.defaultProps, draft => {
        draft.size = 'lg';
        draft.content = '심재철';
    }),
    company: produce(Title.defaultProps, draft => {
        draft.size = 'md';
        draft.content = '코드인디자인 대표';
    }),
    isMobile: false,
    backgroundColor: theme.colors.gray50,
    buttonProps: produce(Button.defaultProps, draft => {
        draft.backgroundColor = theme.colors.white;
        draft.icon = 'chevron-right';
        draft.iconPosition = 'right';
        draft.color = theme.colors.gray500;
        draft.content = '포트폴리오 보러가기';
        draft.border.color = theme.colors.gray500;
        draft.border.width = 1;
    }),
};
const Box = styled(motion.div) `
  background-color: ${props => props.backgroundColor};
  padding: ${props => (props.isMobile ? '20px' : '40px')};
  width: 100%;
  max-width: ${props => (props.isMobile ? '246px' : '367px')};
  margin: 0 auto;
  border-radius: 20px;
`;
const Logo = styled(motion.img) `
  width: ${props => (props.isMobile ? '100px' : '128px')};
  height: ${props => (props.isMobile ? '50px' : '64px')};
  object-fit: contain;
`;
