import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import styled from 'styled-components';
import { motion } from 'framer-motion';
import { isEmpty } from 'lodash-es';
import { produce } from 'immer';
import theme from '../../../../theme';
import { Title, Paragraph } from '../../atoms';
import { Badge } from '../../molecules';
import Button from '../../molecules/Button/Button';
import { Stack } from '../../../layout';
export default function Member1(props) {
    const { thumbnail, badgeListProps, subTitleProps, titleProps, descriptionProps, isMobile, backgroundColor, buttonProps, isReverse } = props;
    return (_jsx(Box, Object.assign({ backgroundColor: backgroundColor, isMobile: isMobile }, { children: _jsxs(Stack, Object.assign({ direction: isMobile ? 'column' : isReverse ? 'row-reverse' : 'row', gap: isMobile ? 40 : 72, alignItems: "center" }, { children: [_jsxs(Stack, Object.assign({ direction: "column", gap: isMobile ? 12 : 20 }, { children: [!isEmpty(badgeListProps) && (_jsx(Stack, Object.assign({ gap: 8 }, { children: badgeListProps.map((badgeProps, index) => {
                                return _jsx(Badge, Object.assign({}, badgeProps), index);
                            }) }))), _jsx(Title, Object.assign({}, titleProps, { isMobile: isMobile })), _jsx(Title, Object.assign({}, subTitleProps, { isMobile: isMobile })), _jsx(Paragraph, Object.assign({}, descriptionProps, { isMobile: isMobile }))] })), _jsx(Thumbnail, { src: thumbnail, isMobile: isMobile })] })) })));
}
Member1.defaultProps = {
    badgeListProps: Array(3).fill(Badge.defaultProps),
    titleProps: produce(Title.defaultProps, draft => {
        draft.fontWeight = 'bold';
        draft.size = 'md';
        draft.color = theme.colors.black;
        draft.content = 'Title 01 타이틀 01\nTitle 02 타이틀 02';
    }),
    subTitleProps: produce(Title.defaultProps, draft => {
        draft.fontWeight = 'bold';
        draft.size = 'sm';
        draft.color = theme.colors.black;
        draft.content = 'Subtitle 01 서브타이틀 01';
    }),
    descriptionProps: produce(Paragraph.defaultProps, draft => {
        draft.fontWeight = 'normal';
        draft.size = 'md';
        draft.color = theme.colors.gray400;
        draft.content = '- 이력 \n - 이력 \n - 이력 \n - 이력';
    }),
    buttonProps: produce(Button.defaultProps, draft => {
        draft.backgroundColor = theme.colors.white;
        draft.icon = 'chevron-right';
        draft.iconPosition = 'right';
        draft.color = theme.colors.gray500;
        draft.content = '포트폴리오 보러가기';
        draft.border.color = theme.colors.gray500;
        draft.border.width = 1;
    }),
    thumbnail: 'https://picsum.photos/id/57/800/800',
    backgroundColor: 'transparent',
    isMobile: false,
    isReverse: false,
};
const Box = styled(motion.div) `
  display: flex;
  flex-direction: ${props => (props.isMobile ? 'column' : 'row')};
  background-color: ${props => props.backgroundColor};
  width: 100%;
  margin: 0 auto;
`;
const Thumbnail = styled(motion.img) `
  width: ${props => (props.isMobile ? '100%' : 'calc(50% - (72px/2))')};
  border-radius: 16px;
`;
