import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useState } from 'react';
import { Navigation, Pagination, Scrollbar, A11y } from 'swiper';
import { Swiper as SwiperReact, SwiperSlide } from 'swiper/react';
import 'swiper/swiper-bundle.min.css';
import { motion } from 'framer-motion';
import { isEmpty } from 'lodash-es';
import styled from 'styled-components';
import { produce } from 'immer';
import theme from '../../../../theme';
import IconButton from '../../molecules/IconButton/IconButton';
import Card1 from '../../organisms/Card1/Card1';
function Carousel1(props) {
    var _a, _b, _c, _d;
    const slides = !isEmpty(props.slides) ? props.slides : [_jsx(Card1, {}), _jsx(Card1, {}), _jsx(Card1, {}), _jsx(Card1, {}), _jsx(Card1, {}), _jsx(Card1, {})];
    const [swiper, setSwiper] = useState();
    /** Framer 버그로 인하여 추가함 (강제 리렌더링) */
    const [reRender, setReRender] = useState(0);
    const isShowPrevButton = !((_a = props === null || props === void 0 ? void 0 : props.prevNavigation) === null || _a === void 0 ? void 0 : _a.isHideOnFirstPage) || !(swiper === null || swiper === void 0 ? void 0 : swiper.isBeginning);
    const isShowNextButton = !((_b = props === null || props === void 0 ? void 0 : props.nextNavigation) === null || _b === void 0 ? void 0 : _b.isHideOnLastPage) || !(swiper === null || swiper === void 0 ? void 0 : swiper.isEnd);
    return (_jsxs(CarouselBox, Object.assign({ padding: props === null || props === void 0 ? void 0 : props.padding }, { children: [_jsx(SwiperReact, Object.assign({ modules: [Navigation, Pagination, Scrollbar, A11y], spaceBetween: props.spaceBetween, slidesPerView: props.slidesPerView, navigation: { prevEl: null, nextEl: null }, pagination: { clickable: true, enabled: false }, scrollbar: { draggable: true, enabled: false }, onSwiper: setSwiper, onSlideChange: swiper => setReRender(prev => prev + 1) }, { children: slides.map((slide, index) => (_jsx(SwiperSlide, { children: slide }, index))) })), isShowPrevButton && (_jsx(PreviousButton, Object.assign({ id: "swiper-custom-button-prev", onClick: () => swiper === null || swiper === void 0 ? void 0 : swiper.slidePrev(), icon: "chevron-left", iconSize: 48, color: theme.colors.white, backgroundColor: theme.colors.black, opacity: 0.2 }, (_c = props === null || props === void 0 ? void 0 : props.prevNavigation) === null || _c === void 0 ? void 0 : _c.buttonProps))), isShowNextButton && _jsx(NextButton, Object.assign({ onClick: () => swiper === null || swiper === void 0 ? void 0 : swiper.slideNext(), icon: "chevron-right", iconSize: 48, color: theme.colors.white, backgroundColor: theme.colors.black, opacity: 0.2 }, (_d = props === null || props === void 0 ? void 0 : props.nextNavigation) === null || _d === void 0 ? void 0 : _d.buttonProps))] })));
}
Carousel1.defaultProps = {
    slides: Array(8).fill(_jsx(Card1, {})),
    spaceBetween: 16,
    slidesPerView: 3.5,
    padding: {
        top: 0,
        bottom: 0,
        left: 0,
        right: 0,
    },
    pagination: false,
    prevNavigation: {
        isHideOnFirstPage: true,
        buttonProps: produce(IconButton.defaultProps, draft => {
            draft.icon = 'chevron-left';
            draft.iconSize = 48;
            draft.color = theme.colors.white;
            draft.backgroundColor = theme.colors.black;
            draft.opacity = 0.2;
        }),
    },
    nextNavigation: {
        isHideOnLastPage: true,
        buttonProps: produce(IconButton.defaultProps, draft => {
            draft.icon = 'chevron-right';
            draft.iconSize = 48;
            draft.color = theme.colors.white;
            draft.backgroundColor = theme.colors.black;
            draft.opacity = 0.2;
        }),
    },
};
export default Carousel1;
const CarouselBox = styled(motion.div) `
  position: relative;
  padding-left: ${props => { var _a; return (_a = props === null || props === void 0 ? void 0 : props.padding) === null || _a === void 0 ? void 0 : _a.left; }}px;
  padding-top: ${props => { var _a; return (_a = props === null || props === void 0 ? void 0 : props.padding) === null || _a === void 0 ? void 0 : _a.top; }}px;
  padding-bottom: ${props => { var _a; return (_a = props === null || props === void 0 ? void 0 : props.padding) === null || _a === void 0 ? void 0 : _a.bottom; }}px;
  padding-right: ${props => { var _a; return (_a = props === null || props === void 0 ? void 0 : props.padding) === null || _a === void 0 ? void 0 : _a.right; }}px;
  .swiper-wrapper {
    display: flex;
  }
`;
const PreviousButton = styled(IconButton) `
  position: absolute;
  top: 50%;
  left: 20px;
  transform: translateY(-50%);
  z-index: 999;
`;
const NextButton = styled(IconButton) `
  position: absolute;
  top: 50%;
  right: 20px;
  transform: translateY(-50%);
  z-index: 999;
`;
