import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import styled from 'styled-components';
import { motion } from 'framer-motion';
import { isEmpty } from 'lodash-es';
import { produce } from 'immer';
import theme from '../../../../theme';
import { Container, Stack } from '../../../layout';
import Paragraph from '../../atoms/Paragraph/Paragraph';
import Title from '../../atoms/Title/Title';
import Badge from '../../molecules/Badge/Badge';
import Button from '../../molecules/Button/Button';
export default function FeatureSection1(props) {
    const { imageUrls, badgeProps, subTitleProps, titleProps, paragraphProps, imageUrl, buttonsProps, backgroundImage, backgroundColor, isMobile, isCenter } = props;
    return (_jsxs(Container, Object.assign({ isMobile: isMobile, direction: "column", isCenter: isCenter, backgroundColor: backgroundColor, backgroundImage: backgroundImage }, { children: [_jsxs(Stack, Object.assign({ direction: "column", gap: 24, alignItems: "center" }, { children: [!isEmpty(imageUrls) && (_jsx(Stack, Object.assign({ gap: 8, justifyContent: "center" }, { children: imageUrls === null || imageUrls === void 0 ? void 0 : imageUrls.map((imageUrl, index) => {
                            return _jsx(IconImage, { src: imageUrl }, index);
                        }) }))), badgeProps.isVisible && (_jsx(Box, { children: _jsx(Badge, Object.assign({}, badgeProps)) })), subTitleProps.isVisible && (_jsx(Box, { children: _jsx(Title, Object.assign({}, subTitleProps, { isMobile: isMobile })) }))] })), titleProps.isVisible && (_jsx(Box, Object.assign({ margin: "0 0 8px" }, { children: _jsx(Title, Object.assign({}, titleProps, { isMobile: isMobile })) }))), paragraphProps.isVisible && (_jsx(Box, { children: _jsx(Paragraph, Object.assign({}, paragraphProps, { isMobile: isMobile })) })), _jsx(Box, Object.assign({ width: "100%", margin: isMobile ? '32px 0 0' : '64px 0 0' }, { children: _jsx(FeatureImage, { src: imageUrl }) })), !isEmpty(buttonsProps) && (_jsx(Stack, Object.assign({ gap: 10, direction: isMobile ? 'column' : 'row', justifyContent: "center", margin: isMobile ? '32px 0 0' : '64px 0 0' }, { children: buttonsProps === null || buttonsProps === void 0 ? void 0 : buttonsProps.map((button, index) => {
                    return (_jsx(ButtonBox, { children: _jsx(Button, Object.assign({}, button, { size: isMobile ? 'md' : 'xl' }), index) }));
                }) })))] })));
}
FeatureSection1.defaultProps = {
    imageUrl: 'https://picsum.photos/id/347/1200',
    imageUrls: ['https://picsum.photos/id/1/32', 'https://picsum.photos/id/2/32', 'https://picsum.photos/id/3/32'],
    badgeProps: Badge.defaultProps,
    subTitleProps: produce(Title.defaultProps, draft => {
        draft.content = 'Subtitle 01 서브타이틀 01';
        draft.size = 'sm';
    }),
    titleProps: produce(Title.defaultProps, draft => {
        draft.content = 'Title 01 타이틀 01\nTitle 01 타이틀 01';
        draft.size = 'lg';
    }),
    paragraphProps: produce(Paragraph.defaultProps, draft => {
        draft.content = 'Body 입력 Body 입력 무엇을 구하지 꽃이 무엇이 천고에 천자만홍이 황금시대다. 피는 대한 따뜻한 꽃 가슴이 봄바람이다.속에서 밥을 끓는 속잎나고.';
        draft.size = 'lg';
        draft.color = theme.colors.gray500;
    }),
    buttonsProps: Array(1).fill(Object.assign(Object.assign({}, Button.defaultProps), { isFullWidth: true, size: 'xl' })),
    backgroundImage: null,
    backgroundColor: 'transparent',
    isMobile: false,
    isCenter: true,
};
const Box = styled(motion.div) `
  width: ${props => props.width};
  margin: ${props => props.margin};
`;
const ButtonBox = styled(motion.div) `
  flex: 1;
  width: 100%;
`;
const FeatureImage = styled(motion.img) `
  width: 100%;
  border-radius: 20px;
  overflow: hidden;
`;
const IconImage = styled(motion.img) `
  height: ${props => (props.isMobile ? '32px' : '40px')};
`;
