import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import styled from 'styled-components';
import { motion } from 'framer-motion';
import { produce } from 'immer';
import { isEmpty } from 'lodash-es';
import theme from '../../../../theme';
import { Container, Stack } from '../../../layout';
import Paragraph from '../../atoms/Paragraph/Paragraph';
import Title from '../../atoms/Title/Title';
import Badge from '../../molecules/Badge/Badge';
import Button from '../../molecules/Button/Button';
import Feature2 from '../../organisms/Feature2/Feature2';
export default function FeatureSection2(props) {
    const { imageUrls, badgeProps, subTitleProps, titleProps, featuresProps, paragraphProps, buttonsProps, backgroundImage, backgroundColor, isMobile } = props;
    return (_jsxs(Container, Object.assign({ isMobile: isMobile, direction: "column", isCenter: true, backgroundColor: backgroundColor, backgroundImage: backgroundImage }, { children: [_jsxs(Stack, Object.assign({ direction: "column", gap: 24, alignItems: "center" }, { children: [!isEmpty(imageUrls) && (_jsx(Stack, Object.assign({ gap: 8, justifyContent: "center" }, { children: imageUrls === null || imageUrls === void 0 ? void 0 : imageUrls.map((imageUrl, index) => {
                            return _jsx(IconImage, { src: imageUrl, isMobile: isMobile }, index);
                        }) }))), _jsx(Badge, Object.assign({}, badgeProps)), _jsx(Title, Object.assign({}, subTitleProps, { isMobile: isMobile }))] })), _jsx(Title, Object.assign({}, titleProps, { isMobile: isMobile, margin: "8px 0 0" })), _jsx(Paragraph, Object.assign({}, paragraphProps, { isMobile: isMobile, margin: "8px 0 0" })), _jsx(FeaturesBox, Object.assign({ isMobile: isMobile }, { children: featuresProps === null || featuresProps === void 0 ? void 0 : featuresProps.map((feature, index) => {
                    return _jsx(Feature2, Object.assign({}, feature, { isMobile: isMobile }), index);
                }) })), !isEmpty(buttonsProps) && (_jsx(Stack, Object.assign({ gap: 10, direction: isMobile ? 'column' : 'row', justifyContent: "center", margin: isMobile ? '32px 0 0' : '64px 0 0' }, { children: buttonsProps === null || buttonsProps === void 0 ? void 0 : buttonsProps.map((button, index) => {
                    return (_jsx(ButtonBox, { children: _jsx(Button, Object.assign({}, button, { size: isMobile ? 'md' : 'xl' }), index) }));
                }) })))] })));
}
FeatureSection2.defaultProps = {
    imageUrls: ['https://picsum.photos/id/1/32', 'https://picsum.photos/id/2/32', 'https://picsum.photos/id/3/32'],
    badgeProps: Badge.defaultProps,
    subTitleProps: produce(Title.defaultProps, draft => {
        draft.content = 'Subtitle 01 서브타이틀 01';
        draft.size = 'sm';
        draft.textAlign = 'center';
    }),
    titleProps: produce(Title.defaultProps, draft => {
        draft.content = 'Title 01 타이틀 01\nTitle 01 타이틀 01';
        draft.size = 'lg';
        draft.textAlign = 'center';
    }),
    paragraphProps: produce(Paragraph.defaultProps, draft => {
        draft.content = 'Body 입력 Body 입력 무엇을 구하지 꽃이 무엇이 천고에 천자만홍이 황금시대다. 피는 대한 따뜻한 꽃 가슴이 봄바람이다.속에서 밥을 끓는 속잎나고.';
        draft.size = 'lg';
        draft.textAlign = 'center';
        draft.color = theme.colors.gray500;
    }),
    featuresProps: Array(1).fill(Feature2.defaultProps),
    buttonsProps: Array(1).fill(produce(Button.defaultProps, draft => {
        draft.isFullWidth = true;
        draft.size = 'xl';
    })),
    backgroundImage: 'https://picsum.photos/id/356/1200',
    backgroundColor: 'transparent',
    isMobile: false,
};
const ButtonBox = styled(motion.div) `
  flex: 1;
  width: 100%;
`;
const FeaturesBox = styled(motion.div) `
  width: 100%;
  display: flex;
  margin-top: 64px;
  gap: 24px;

  ${props => props.isMobile &&
    `
        flex-direction: column;
        gap: 32px;
        margin-top: 32px;
    `};
`;
const IconImage = styled(motion.img) `
  height: ${props => (props.isMobile ? '32px' : '40px')};
`;
