import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import styled from 'styled-components';
import { motion } from 'framer-motion';
import { produce } from 'immer';
import { isEmpty } from 'lodash-es';
import theme from '../../../../theme';
import { Container, Stack } from '../../../layout';
import Divider from '../../atoms/Divider/Divider';
import Paragraph from '../../atoms/Paragraph/Paragraph';
import Title from '../../atoms/Title/Title';
import Button from '../../molecules/Button/Button';
export default function Footer2(props) {
    const { titleProps, paragraphProps, buttonsProps, footerItems1, footerItems2, footerItems3, footerItems4, copyrightProps, backgroundImage, backgroundColor, isMobile, isCenter, paddingY } = props;
    return (_jsxs(Container, Object.assign({ isMobile: isMobile, direction: "column", isCenter: isCenter || isMobile, backgroundColor: backgroundColor, backgroundImage: backgroundImage, padding: `${paddingY}px 0` }, { children: [titleProps.isVisible && (_jsx(Box, Object.assign({ margin: "0 0 8px" }, { children: _jsx(Title, Object.assign({}, titleProps, { isMobile: isMobile })) }))), paragraphProps.isVisible && (_jsx(Box, Object.assign({ margin: isMobile ? '0 0 32px' : '0 0 64px' }, { children: _jsx(Paragraph, Object.assign({}, paragraphProps, { isMobile: isMobile, textAlign: isMobile ? 'center' : 'left' })) }))), !isMobile && (_jsxs(Stack, Object.assign({ direction: "column", gap: 12 }, { children: [!isEmpty(footerItems1) && _jsx(FooterItems, { items: footerItems1 }), !isEmpty(footerItems2) && _jsx(FooterItems, { items: footerItems2 }), !isEmpty(footerItems3) && _jsx(FooterItems, { items: footerItems3 }), !isEmpty(footerItems4) && _jsx(FooterItems, { items: footerItems4 })] }))), isMobile && (_jsxs(Stack, Object.assign({ direction: "column", gap: 12 }, { children: [!isEmpty(footerItems1) && _jsx(MobileFooterItems, { items: footerItems1 }), !isEmpty(footerItems2) && _jsx(MobileFooterItems, { items: footerItems2 }), !isEmpty(footerItems3) && _jsx(MobileFooterItems, { items: footerItems3 }), !isEmpty(footerItems4) && _jsx(MobileFooterItems, { items: footerItems4 })] }))), _jsx(Box, Object.assign({ width: "100%" }, { children: _jsx(Divider, { margin: isMobile ? '32px 0' : '40px 0', color: theme.colors.gray100, isFullWidth: true }) })), _jsxs(Stack, Object.assign({ direction: isMobile ? 'column' : 'row', justifyContent: "space-between", gap: isMobile ? 12 : 0 }, { children: [!isEmpty(buttonsProps) && (_jsx(Stack, Object.assign({ gap: 12, direction: 'row', flexWrap: "wrap" }, { children: buttonsProps === null || buttonsProps === void 0 ? void 0 : buttonsProps.map((button, index) => {
                            return _jsx(Button, Object.assign({}, button), index);
                        }) }))), _jsx(Paragraph, Object.assign({}, copyrightProps, { whiteSpace: "nowrap", isMobile: isMobile }))] }))] })));
}
function FooterItems({ items }) {
    return (_jsx(Stack, Object.assign({ gap: 12, direction: "row", justifyContent: "flex-start", alignItems: "center" }, { children: items === null || items === void 0 ? void 0 : items.map((item, index) => {
            const isLastIndex = (items === null || items === void 0 ? void 0 : items.length) - 1 === index;
            return (_jsxs(_Fragment, { children: [_jsxs(Stack, Object.assign({ gap: 10, direction: "row", alignItems: "center", width: "auto" }, { children: [_jsx(Paragraph, Object.assign({}, item.titleProps, { whiteSpace: "nowrap" })), _jsx(Paragraph, Object.assign({}, item.descriptionProps))] })), !isLastIndex && _jsx(Divider, { color: theme.colors.gray100, length: 20, direction: "vertical" })] }));
        }) })));
}
function MobileFooterItems({ items }) {
    return (_jsx(Stack, Object.assign({ gap: 12, direction: "column", justifyContent: "flex-start", alignItems: "flex-start" }, { children: items === null || items === void 0 ? void 0 : items.map((item, index) => {
            return (_jsx(_Fragment, { children: _jsxs(Stack, Object.assign({ gap: 10, direction: "row", alignItems: "flex-start", width: "auto" }, { children: [_jsx(Paragraph, Object.assign({}, item.titleProps, { whiteSpace: "nowrap", isMobile: true })), _jsx(Paragraph, Object.assign({}, item.descriptionProps, { isMobile: true }))] })) }));
        }) })));
}
Footer2.defaultProps = {
    titleProps: produce(Title.defaultProps, draft => {
        draft.content = 'Title 01 타이틀 01\nTitle 02 타이틀 02';
        draft.size = 'lg';
        draft.highlight.color = theme.colors.gray500;
    }),
    paragraphProps: produce(Paragraph.defaultProps, draft => {
        draft.content = 'Body 입력 Body 입력 무엇을 구하지 꽃이 무엇이 천고에 천자만홍이 황금시대다. 피는 대한 따뜻한 꽃 가슴이 봄바람이다.속에서 밥을 끓는 속잎나고.';
        draft.size = 'lg';
        draft.color = theme.colors.gray500;
    }),
    footerItems1: [
        {
            titleProps: produce(Paragraph.defaultProps, draft => {
                draft.content = '코드인디자인 CodeInDesign';
                draft.fontWeight = 'bold';
            }),
            descriptionProps: produce(Paragraph.defaultProps, draft => {
                draft.content = '';
                draft.isVisible = false;
            }),
        },
    ],
    footerItems2: [
        {
            titleProps: produce(Paragraph.defaultProps, draft => {
                draft.content = 'E-mail';
                draft.fontWeight = 'bold';
            }),
            descriptionProps: produce(Paragraph.defaultProps, draft => {
                draft.content = 'codeindesign.official@gmail.com';
            }),
        },
    ],
    footerItems3: [
        {
            titleProps: produce(Paragraph.defaultProps, draft => {
                draft.content = '주소';
                draft.fontWeight = 'bold';
            }),
            descriptionProps: produce(Paragraph.defaultProps, draft => {
                draft.content = '서울특별시 송파구 잠실동 204-13 4층';
            }),
        },
    ],
    footerItems4: [
        {
            titleProps: produce(Paragraph.defaultProps, draft => {
                draft.content = '주소';
                draft.fontWeight = 'bold';
            }),
            descriptionProps: produce(Paragraph.defaultProps, draft => {
                draft.content = '서울특별시 송파구 잠실동 204-13 4층';
            }),
        },
    ],
    copyrightProps: produce(Paragraph.defaultProps, draft => {
        draft.content = 'All Rights Reserved.';
        draft.size = 'md';
        draft.color = theme.colors.gray300;
    }),
    buttonsProps: Array(1).fill(produce(Button.defaultProps, draft => {
        draft.size = 'sm';
        draft.buttonType = 'link';
        draft.color = theme.colors.black;
    })),
    backgroundImage: 'https://picsum.photos/id/347/2000',
    backgroundColor: 'transparent',
    isMobile: false,
    isCenter: true,
    paddingY: 100,
};
const Box = styled(motion.div) `
  margin: ${props => props.margin};
  width: ${props => props.width};
  background-color: ${props => props.backgroundColor};
  background-image: url('${props => props.backgroundImage}');
  background-size: cover;
`;
const ButtonBox = styled(motion.div) `
  flex: 1;
  width: 100%;
`;
const FeatureImage = styled(motion.img) `
  width: 100%;
  height: 600px;
  object-fit: cover;
  border-radius: 20px;
  overflow: hidden;
`;
