import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import styled from 'styled-components';
import { motion } from 'framer-motion';
import { isEmpty } from 'lodash-es';
import { produce } from 'immer';
import theme from '../../../../theme';
import { Container, Stack } from '../../../layout';
import Paragraph from '../../atoms/Paragraph/Paragraph';
import { Badge, Button } from '../../molecules';
import Member1 from '../../organisms/Member1/Member1';
import Title from '../../atoms/Title/Title';
export default function MemberSection1(props) {
    const { badgeProps, subTitleProps, titleProps, descriptionProps, memberListProps, buttonsProps, backgroundImage, backgroundColor, isMobile } = props;
    const isVisibleTitleArea = subTitleProps.isVisible || titleProps.isVisible || descriptionProps.isVisible;
    return (_jsx(Container, Object.assign({ isMobile: isMobile, direction: "column", isCenter: true, backgroundColor: backgroundColor, backgroundImage: backgroundImage }, { children: _jsxs(Stack, Object.assign({ direction: "column", gap: 64 }, { children: [isVisibleTitleArea && (_jsxs(Stack, Object.assign({ direction: "column", gap: 24, alignItems: "center" }, { children: [_jsx(Badge, Object.assign({}, badgeProps)), _jsxs(Stack, Object.assign({ direction: "column", gap: 8, alignItems: "center" }, { children: [_jsx(Title, Object.assign({}, subTitleProps, { isMobile: isMobile })), _jsx(Title, Object.assign({}, titleProps, { isMobile: isMobile })), _jsx(Paragraph, Object.assign({}, descriptionProps, { isMobile: isMobile }))] }))] }))), _jsx(Stack, Object.assign({ direction: "column", gap: isMobile ? 80 : 120 }, { children: memberListProps === null || memberListProps === void 0 ? void 0 : memberListProps.map((feature, index) => {
                        return _jsx(Member1, Object.assign({}, feature, { isMobile: isMobile }), index);
                    }) })), !isEmpty(buttonsProps) && (_jsx(Stack, Object.assign({ gap: 12, direction: isMobile ? 'column' : 'row', justifyContent: "center" }, { children: buttonsProps === null || buttonsProps === void 0 ? void 0 : buttonsProps.map((button, index) => {
                        return (_jsx(ButtonBox, { children: _jsx(Button, Object.assign({}, button, { size: isMobile ? 'md' : 'xl' }), index) }));
                    }) })))] })) })));
}
MemberSection1.defaultProps = {
    badgeProps: produce(Badge.defaultProps, draft => { }),
    subTitleProps: produce(Title.defaultProps, draft => {
        draft.content = 'Subtitle 01 서브타이틀 01';
        draft.size = 'sm';
        draft.textAlign = 'center';
    }),
    titleProps: produce(Title.defaultProps, draft => {
        draft.content = 'Title 01 타이틀 01\nTitle 01 타이틀 01';
        draft.size = 'lg';
        draft.textAlign = 'center';
    }),
    descriptionProps: produce(Paragraph.defaultProps, draft => {
        draft.content = 'Body 입력 Body 입력 무엇을 구하지 꽃이 무엇이 천고에 천자만홍이 황금시대다. 피는 대한 따뜻한 꽃 가슴이 봄바람이다. 속에서 밥을 끓는 속잎나고.';
        draft.size = 'lg';
        draft.textAlign = 'center';
        draft.color = theme.colors.gray500;
    }),
    memberListProps: Array(1).fill(Member1.defaultProps),
    buttonsProps: Array(3).fill(produce(Button.defaultProps, draft => {
        draft.isFullWidth = true;
        draft.size = 'xl';
    })),
    backgroundColor: 'transparent',
    isMobile: false,
};
const ButtonBox = styled(motion.div) `
  flex: 1;
  width: 100%;
`;
