import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { motion } from 'framer-motion';
import { produce } from 'immer';
import styled from 'styled-components';
import { isEmpty } from 'lodash-es';
import { Container } from '../../../layout';
import Title from '../../atoms/Title/Title';
import Carousel1 from '../Carousel1/Carousel1';
import { Card1 } from '../../organisms';
// Title + Carousel
export default function Review5(props) {
    const slides = !isEmpty(props.slides) ? props.slides : [];
    return (_jsxs(ReviewBox, Object.assign({ backgroundColor: props.backgroundColor, padding: props === null || props === void 0 ? void 0 : props.padding, isMobile: props.isMobile }, { children: [_jsx(Container, Object.assign({ isMobile: props.isMobile, direction: "column", isCenter: true, backgroundColor: props.backgroundColor, padding: `0 0 ${props.gap}px 0` }, { children: _jsx(Title, Object.assign({}, props.titleProps, { isMobile: props.isMobile })) })), _jsx(CarouselBox, Object.assign({ isMobile: props.isMobile }, { children: _jsx(Carousel1, Object.assign({}, props.carouselProps, { slides: slides })) }))] })));
}
Review5.defaultProps = {
    titleProps: produce(Title.defaultProps, draft => {
        draft.content = '1인 기업부터 연매출 40억 기업까지,\n 80개의 기업이 인정했습니다.';
        draft.size = 'lg';
        draft.textAlign = 'center';
    }),
    carouselProps: produce(Carousel1.defaultProps, draft => {
        draft.slidesPerView = 3.5;
        draft.padding.left = 92;
        draft.pagination = true;
    }),
    slides: Array(5).fill(_jsx(Card1, {})),
    backgroundColor: '#FFEBCB',
    gap: 64,
    padding: {
        top: 80,
        bottom: 80,
        right: 0,
        left: 0,
    },
    isMobile: false,
};
const CarouselBox = styled.div `
  width: 100%;
  ${props => {
    return (props.isMobile &&
        `
                overflow: hidden;
            `);
}}
  overflow: hidden;
`;
const ReviewBox = styled(motion.div) `
  width: 100%;
  background-color: ${props => props.backgroundColor};
  padding-left: ${props => { var _a; return (_a = props === null || props === void 0 ? void 0 : props.padding) === null || _a === void 0 ? void 0 : _a.left; }}px;
  padding-right: ${props => { var _a; return (_a = props === null || props === void 0 ? void 0 : props.padding) === null || _a === void 0 ? void 0 : _a.right; }}px;
  padding-top: ${props => { var _a; return (_a = props === null || props === void 0 ? void 0 : props.padding) === null || _a === void 0 ? void 0 : _a.top; }}px;
  padding-bottom: ${props => { var _a; return (_a = props === null || props === void 0 ? void 0 : props.padding) === null || _a === void 0 ? void 0 : _a.bottom; }}px;
  ${props => {
    return (props.isMobile &&
        `
            max-width: 375px;
        `);
}};
  margin: 0 auto;
`;
