import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import styled from 'styled-components';
import { motion } from 'framer-motion';
import { produce } from 'immer';
import theme from '../../../../theme';
import { Container, Stack } from '../../../layout';
import { Title, Paragraph } from '../../atoms';
import { isEmpty } from 'lodash-es';
export default function TextSection2(props) {
    const { isMobile, subTitleProps, titleProps, features, backgroundImage, backgroundColor, contentBackgroundColor, contentPadding } = props;
    return (_jsx(Container, Object.assign({ isMobile: isMobile, backgroundColor: backgroundColor, backgroundImage: backgroundImage }, { children: _jsx(ContentBox, Object.assign({ isMobile: isMobile, backgroundColor: contentBackgroundColor, padding: contentPadding }, { children: _jsxs(Stack, Object.assign({ direction: "column", gap: 40 }, { children: [_jsxs(Stack, Object.assign({ direction: "column", gap: 8, alignItems: "center" }, { children: [_jsx(Title, Object.assign({}, subTitleProps, { isMobile: isMobile })), _jsx(Title, Object.assign({}, titleProps, { isMobile: isMobile }))] })), !isEmpty(features) && (_jsx(Stack, Object.assign({ direction: isMobile ? 'column' : 'row', gap: isMobile ? 32 : 40 }, { children: features === null || features === void 0 ? void 0 : features.map((feature, index) => {
                            const titleProps = feature === null || feature === void 0 ? void 0 : feature.titleProps;
                            const descriptionProps = feature === null || feature === void 0 ? void 0 : feature.descriptionProps;
                            return (_jsxs(Stack, Object.assign({ direction: "column", gap: isMobile ? 12 : 24 }, { children: [_jsx(Title, Object.assign({}, titleProps, { isMobile: isMobile })), _jsx(Paragraph, Object.assign({}, descriptionProps, { isMobile: isMobile }))] }), index));
                        }) })))] })) })) })));
}
TextSection2.defaultProps = {
    subTitleProps: produce(Title.defaultProps, draft => {
        draft.content = 'Subtitle 서브타이틀';
        draft.size = 'sm';
        draft.fontWeight = 'normal';
    }),
    titleProps: produce(Title.defaultProps, draft => {
        draft.content = 'Title 타이틀';
        draft.size = 'lg';
        draft.fontWeight = 'normal';
    }),
    features: Array(3).fill({
        titleProps: produce(Title.defaultProps, draft => {
            draft.content = 'Feature Title 01';
            draft.size = 'md';
            draft.fontWeight = 'bold';
        }),
        descriptionProps: produce(Paragraph.defaultProps, draft => {
            draft.content = '콘텐츠와 지도를 이어 풍성한 정보와 재미를 줍니다. 지도 기반의 알고리즘을 통해 더 많은 팔로워를 확보해보세요. 시그니처 스탬프, 광고를 활용하여 수익을 개선해보세요.';
            draft.size = 'md';
            draft.fontWeight = 'normal';
        }),
    }),
    backgroundImage: '',
    backgroundColor: 'transparent',
    contentBackgroundColor: theme.colors.gray50,
    contentPadding: {
        top: 64,
        bottom: 64,
        left: 80,
        right: 80,
        isApply: false,
    },
    isMobile: false,
};
const ContentBox = styled(motion.div) `
  display: flex;
  width: 100%;
  background: ${props => props.backgroundColor};
  border-radius: 20px;
  padding: ${props => (props.isMobile ? '64px 16px' : '64px 80px')};
  ${({ padding }) => (padding === null || padding === void 0 ? void 0 : padding.isApply) && `padding-top: ${padding === null || padding === void 0 ? void 0 : padding.top}px;`}
  ${({ padding }) => (padding === null || padding === void 0 ? void 0 : padding.isApply) && `padding-bottom: ${padding === null || padding === void 0 ? void 0 : padding.bottom}px;`}
  ${({ padding }) => (padding === null || padding === void 0 ? void 0 : padding.isApply) && `padding-left: ${padding === null || padding === void 0 ? void 0 : padding.left}px;`}
  ${({ padding }) => (padding === null || padding === void 0 ? void 0 : padding.isApply) && `padding-right: ${padding === null || padding === void 0 ? void 0 : padding.right}px;`}  
  overflow: hidden;
`;
