var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import styled from 'styled-components';
import { motion } from 'framer-motion';
/** Contaiener 컴포넌트는 컨텐츠의 최대 가로폭을 지정하는 역할을 합니다. */
export default function Container(props) {
    const { children, padding } = props, remain = __rest(props, ["children", "padding"]);
    return (_jsx(Box, Object.assign({ padding: padding }, remain, { children: _jsx(ContentBox, Object.assign({}, remain, { children: children })) })));
}
Container.defaultProps = {
    direction: 'row',
    isMobile: false,
    isCenter: false,
    backgroundColor: 'transparent',
};
const Box = styled(motion.div) `
  display: flex;
  width: 100%;
  margin: 0 auto;
  box-sizing: boder-box;
  padding: ${props => (props.padding ? props.padding : props.isMobile ? '80px 0' : '120px 0')};
  background-color: ${props => props.backgroundColor};
  background-image: url(${props => props.backgroundImage});
  background-size: cover;

  ${props => props.isMobile &&
    `
        padding-left: 16px;
        padding-right: 16px;
    `};
`;
const ContentBox = styled(motion.div) `
  display: flex;
  width: 100%;
  flex-direction: ${props => props.direction};
  max-width: 1056px;
  margin: 0 auto;
  ${props => props.isCenter &&
    `
        justify-content: center;
        align-items: center;
    `};
`;
