import useBreakpoints from '@thebiltheory/usebreakpoints';
import { isEmpty, last } from 'lodash-es';
import theme from '../theme';
const myBreakpoints = Object.values(theme['breakpoints']);
const useBreakPointValue = (props, breakpoints = myBreakpoints) => {
    if (isEmpty(props))
        return null;
    const lastValue = last(props);
    const [value] = useBreakpoints(props, breakpoints);
    if (value === null || value === undefined) {
        for (let i = 2; i >= 0; i--) {
            if (props && (props === null || props === void 0 ? void 0 : props[i]))
                return props === null || props === void 0 ? void 0 : props[i];
            else
                return lastValue;
        }
    }
    return value;
};
export default useBreakPointValue;
