var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { useCallback } from 'react';
import { useState } from 'react';
import { firestorage } from '../configs/firebase';
import { uid } from 'uid';
import { css } from '@emotion/react';
import FileUtils from '../utils/FileUtils';
const useEditor = () => {
    const [isImageUploading, setIsImageUploading] = useState(false);
    const onImageChanged = useCallback((file, renderImage) => __awaiter(void 0, void 0, void 0, function* () {
        setIsImageUploading(true);
        const compressedFile = yield FileUtils.compressFile(file);
        const storageRef = firestorage.ref(`/images/${uid(25)}`);
        yield storageRef.put(compressedFile);
        const downloadUrl = yield storageRef.getDownloadURL();
        renderImage(downloadUrl, '이미지');
        setIsImageUploading(false);
    }), []);
    return { onImageChanged, isImageUploading, setIsImageUploading };
};
export default useEditor;
export const EditorHtmlStyle = css `
  br {
    display: none;
  }
  p + p {
    margin-top: 1em;
  }
  .image-wrapper {
    position: relative;
    width: 100%;
    margin: 16px auto;
    img {
      margin: auto;
      max-width: 100%;
      max-height: 400px;
    }
  }
`;
