var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var _a;
import imageCompression from 'browser-image-compression';
class FileUtils {
}
_a = FileUtils;
FileUtils.compressFile = (file, compressOption) => __awaiter(void 0, void 0, void 0, function* () {
    const fileCompressOptions = compressOption || {
        maxSizeMB: 0.5,
        maxWidthOrHeight: 1024,
        useWebWorker: true,
    };
    const compressedFile = (yield imageCompression(file, fileCompressOptions));
    console.log(`압축된 파일 사이즈: ${compressedFile.size / 1024 / 1024} MB`);
    return compressedFile;
});
FileUtils.readFileAsDataURL = (file) => __awaiter(void 0, void 0, void 0, function* () {
    if (!file)
        return Promise.resolve(null);
    const compressedFile = yield FileUtils.compressFile(file);
    return imageCompression.getDataUrlFromFile(compressedFile);
});
FileUtils.readFilesAsDataURL = (files) => __awaiter(void 0, void 0, void 0, function* () {
    if (!files || !files.length)
        return Promise.resolve(null);
    const promises = [];
    for (let i = 0; i < files.length; i++) {
        const file = files[i];
        promises.push(new Promise(resolve => FileUtils.readFileAsDataURL(file).then(dataUri => resolve(dataUri))));
    }
    return Promise.all(promises).then(dataUris => dataUris);
});
export default FileUtils;
